/***************************************************************************
                          m_stacked_pair.h  -  description
                             -------------------
    begin                : Thu Apr 11 2002
    copyright            : (C) 2002 by Mirela Andronescu
    email                : andrones@cs.ubc.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef M_STACKED_PAIR_H
#define M_STACKED_PAIR_H

class m_energy_matrix;

class m_stacked_pair
{
    public:

        friend class m_energy_matrix;

        m_stacked_pair (int *seq, int num_b, int *b, int length);
        // The constructor

        ~m_stacked_pair ();
        // The destructor
    
        void set_energy_matrix (m_energy_matrix *V) { this->V = V; }
        // Set local energy matrix to V
    
        int compute_energy (int i, int j);
        // compute the free energy of the structure closed by this stacked pair

        static int get_energy (int i, int j, int *sequence, int num_b, int *b);
        // returns the free energy of the stacked pair closed at (i,j)   
        
        static int get_enthalpy (int i, int j, int *sequence, int num_b, int *b);       
        // returns the enthalpy of the stacked pair closed at (i,j)    
                
    private:
        int *sequence;             // the entire sequence for which we compute the energy
        int seqlen;                 // sequence length
        m_energy_matrix *V;           // a pointer to the free energy matrix V

        // we have num_b b's in MultiFold
        int *b;
        int num_b;

};

#include "m_energy_matrix.h"
#endif
